# 一. 目标：

使用双端 USB 线连接 GDK7，并使用 NanoCode 调试 GDK7（Linux 环境）。

---

# 二. 准备：

本示例中，NanoCode（版本 1.76.2）运行环境为 Windows 10 64 位。

## 2.1 硬件准备：

* GDK7
* 双端 USB 线

## 2.2 软件准备：

点击下载以下蓝色链接：

> DCI 驱动和 OpenIPC 软件用于支持英特尔的 DCI 调试技术，包含在英特尔的多个软件包中，比如 Intel System Debugger（ISD）、Intel oneAPI 开发套件等。考虑到 ISD 等软件包的体量巨大，很多用户在安装时遇到问题，所以我们选取了其中部分模块，以方便 GDK7 用户。这些软件的版权归英特尔公司所有。

* [英特尔 DCI 驱动和 Open IPC 软件](https://gedu.oss-cn-beijing.aliyuncs.com/Products/GDK7/DCI/DCI.zip "英特尔 DCI 驱动和 Open IPC 软件")

---

# 三. 详细步骤：

1.  **安装 NanoCode：**
    * 首先在非 GDK7 的机器上安装 NanoCode。
    * 点击以下链接下载安装最新版 NanoCode：
        * [https://www.nanocode.cn/#/nanocode/index-1](https://www.nanocode.cn/#/nanocode/index-1)
    * 安装完成后，首次打开 NanoCode，点击右下角的版本号（例如 `2.7.40`）手动更新，然后按照提示更新插件并重启 NanoCode。
     ![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_d50825ef6576a2297b717f3252b40e79_r.png)
2.  **安装 DCI 驱动：**
    * 将下载的 `DCI.zip` 解压，放到安装 NanoCode 的机器上。
    * 解压后，将 `DCI` 文件夹放在默认 NanoCode 的安装路径（`C:\NanoCode\IPC`）下，如下图所示：
     ![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_e1e02d6467f8b23adb53f5d07f161605_r.png)
    * 运行DCI目录中的`dcidrv.msi`程序，也就是安装DCI的USB驱动

3.  **连接 GDK7：**
    * 使用随 GDK7 发货的蓝色双端 USB 线将电脑和 GDK7 连接起来。
    * 如下图所示，白色机器为 GDK7，蓝色 USB 口必须插在这个位置；黑色机器为安装 NanoCode 的机器，也插入 USB 口。
     ![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_fdf174a1fed2659083099e2701ffd30e_r.png)
4.  **获取 KGB 值：**
    * 开机在 GRUB 界面，选择进入 `Ubuntu`，然后回车进入。默认密码为 `gd2020`。
    * 按 `Ctrl+Alt+T` 打开命令行终端，输入命令 `cat /proc/ndb`，记下 `kgb` 的值，例如 `ffffffffff5ff000`（以实际机器输出为准）。
     ![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_171f06bec1f50985a555234d0510be0b_r.png)
5.  **配置 NanoCode的调试启动参数：**
    * 打开 NanoCode，在 Nano 主页选择第一个 Nano 调试，点击 “去调试”，然后选择 “DCI OPEN”。
     ![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_108e67e659ff489b9ef11be24d0f6fdb_r.png)
    * 将前面记下的 `kgb` 值输入到框中，并在地址前添加 `0x`。
    * 其他选项设置应与下图相同：
        * 选择 `DCI Open`。
        * 输入 `gdk7`。
        * 输入 `0x+kgb` 的地址（例如 `0xffffffffff5ff000`）。
        * 勾选 `Reconnect`、`Force Hardware BP`、`Memory Shadow` 和 `Linux Kernel`。
    * 确认无误后，点击 “启动”。
     ![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_b01f7d6ebb298ff80c4fc22e0719a64a_r.png)
6.  **调试 GDK7：**
    * 出现 “Running” 提示后，点击上方中断按钮，将 GDK7 中断。
     ![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_a69c91ad2e82b0216b415779352c6f3a_r.png)
    * 此时可以输入 `r` 或 `lm` 命令。
     ![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_eb20ed72ce259692c75705b1bb974bf9_r.png)
7.  **符号化调试：**
    * 如果 `k` 命令等无法正常工作，需要设置被调试机器（GDK7 Ubuntu 系统）的符号和代码文件路径。
    * 参考以下文章进行设置：
        * [调试 GDK7 的 Linux 系统（下）：符号化调试](https://www.nanocode.cn/wiki/docs/gdk7_primer/debug_gdk7_0 "调试 GDK7 的 Linux 系统（下）：符号化调试")

## 附录：可能遇到的问题

* 如果不是 Running 状态，检查 USB 线是否连接松动。
* 如果 Running 状态后中断失败，尝试以下步骤：

### 1. 打开设备管理器

* 在 Windows 主机上右击 “此电脑”，点击 “管理”，打开 “计算机管理”，然后在 “系统工具” 中点击 “设备管理器”。

### 2. 重新启用设备

* 在 “设备管理器” 中找到失败的设备，右击选择 “禁用设备”，然后重新启用。
 ![](https://www.nanocode.cn/wiki/uploads/gdk7_primer/images/m_822d13a44a3ad2a930a0afe4c5bfb3ed_r.png)

### 3. 检查驱动配置
* 检查是否安装好前面说的`dcidrv.msi`驱动程序，并检查`C:\NanoCode\IPC\DCI\openipc-windows-1.2011.4508.100-1.0\tools\OpenIPC_1.2011.4508.100\Bin\OpenIPC_x64.exe`路径是否正确。
* 手动启动`OpenIPC_x64.exe`看能不能运行成功。


### 4. 再次尝试中断

* 回到 NanoCode 界面，再次尝试中断。